--Textured Polygon Demo - using xXxMoNkEyMaNxXx's PixelEffect
local sin, cos, atan2, sqrt, pi, floor = math.sin, math.cos, math.atan2, math.sqrt, math.pi, math.floor
local random, max, min = math.random, math.max, math.min
local gr, tm, ky = love.graphics, love.timer, love.keyboard

local tex = require 'texture_effect'

function love.load()
	tex.load()
	image 	= gr.newImage( 'lenaC.jpg' )
	brick	= gr.newImage( 'brick.jpg' )
	star	= gr.newImage( 'StarTran.png' )
	width, height = gr.getWidth(), gr.getHeight()
	gr.setBackgroundColor( 55, 55, 255, 255 )
	gr.setCaption( 'Quad Texturing Effect Test' )

	sqr 	= { {250, 450}, {550, 450}, {550, 150}, {250, 150} }
	sqr2	= { {700, 500}, {600, 500}, {600, 400}, {700, 400} }

	wall1	= { {  0,   0}, {225, 225}, {225, 275}, {  0, 500} }
	wall2	= { {500,   0}, {275, 225}, {275, 275}, {500, 500} }

	canvas	= gr.newCanvas( 500, 500 )
		tex.effect.send ( tex.effect, "SIZEY",500)
		canvas:clear( 255, 255, 255, 0 )
		gr.setCanvas( canvas )
		tex.quad( brick, wall1, {0,0}, {2,2} )
		tex.quad( brick, wall2, {0,0}, {2,2} )
		gr.setCanvas()
	tex.effect.send ( tex.effect, "SIZEY",gr.getHeight())
	ang		= 0
	sz		= 0.1
	dir		= 1
	end

function love.draw()
	gr.setColor(255,255,255,255)
	gr.draw( canvas, 400, 300, ang, sz, sz, 250, 250 )
	--[[tex.quad( brick, wall1, {0,0}, {2,2} )
		tex.quad( brick, wall2, {0,0}, {2,2} )]]
	tex.quad( image, sqr)

	gr.setColor( 255, 255, 0, 255 )
	for i = 1, #sqr do gr.circle('fill', sqr[i][1], sqr[i][2], 4 ) end
	gr.print( 'fps: '..tm.getFPS( ), width-100, height-20 )

	gr.setColor(255,255,255,0)
	tex.quad( star, sqr2, { a, b }, { c, d } )
	end

function love.keypressed( key )
	if key == "escape" then love.event.quit()	end
	end

function love.update( dt )
	sqr[1][1]=clamp(sqr[1][1]+random(-1,1),100,350)
	sqr[1][2]=clamp(sqr[1][2]+random(-1,1),350,500)
	sqr[2][1]=clamp(sqr[2][1]+random(-1,1),450,700)
	sqr[2][2]=clamp(sqr[2][2]+random(-1,1),350,500)
	sqr[3][1]=clamp(sqr[3][1]+random(-1,1),450,700)
	sqr[3][2]=clamp(sqr[3][2]+random(-1,1),100,250)
	sqr[4][1]=clamp(sqr[4][1]+random(-1,1),100,350)
	sqr[4][2]=clamp(sqr[4][2]+random(-1,1),100,250)
	a = random( 0, 1 ) / 12
	b = random( 0, 1 ) / 12
	c = 1 - 2 * a
	d = 1 - 2 * b
	ang = ang + dt
	sz  = sz + dir * dt
	if sz > 4   then dir = - dir sz = sz - 0.01 end
	if sz < 0.1 then dir = -dir sz = sz + 0.01 end

	end

function clamp(val,low,high)
	return max(low, min( val, high ) )
	end

